/*----- PROTECTED REGION ID(Keithley2001Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        Keithley2001Class.h
//
// description : Include for the Keithley2001 root class.
//               This class is the singleton class for
//                the Keithley2001 device class.
//               It contains all properties and methods which the 
//               Keithley2001 requires only once e.g. the commands.
//
// project :     Keithley 2001
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Keithley2001Class_H
#define Keithley2001Class_H

#include <tango.h>
#include "Keithley2001.h"


/*----- PROTECTED REGION END -----*/	//	Keithley2001Class.h


namespace Keithley2001_ns
{
/*----- PROTECTED REGION ID(Keithley2001Class::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Keithley2001Class::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute temperature class definition
class temperatureAttrib: public Tango::Attr
{
public:
	temperatureAttrib():Attr("temperature",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~temperatureAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Keithley2001 *>(dev))->read_temperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Keithley2001 *>(dev))->is_temperature_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command SaveConfig class definition
class SaveConfigClass : public Tango::Command
{
public:
	SaveConfigClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SaveConfigClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SaveConfigClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Keithley2001 *>(dev))->is_SaveConfig_allowed(any);}
};

//	Command RestoreConfig class definition
class RestoreConfigClass : public Tango::Command
{
public:
	RestoreConfigClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	RestoreConfigClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~RestoreConfigClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Keithley2001 *>(dev))->is_RestoreConfig_allowed(any);}
};


/**
 *	The Keithley2001Class singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Keithley2001Class : public Tango::DeviceClass
#else
class Keithley2001Class : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(Keithley2001Class::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001Class::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static Keithley2001Class *init(const char *);
		static Keithley2001Class *instance();
		~Keithley2001Class();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		Keithley2001Class(string &);
		static Keithley2001Class *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	Keithley2001_H
